/*****************************************************************
** Ȩ:  Ƽ޹˾
** ļ: LSD_ES44X1_LCD.c
** 汾V1.0
** :IAR Embedded Workbench Evaluation for MSP430 4.21
** LSD_ES44X1LCDʾֺ壬ʵزʾѹʵ
** :Huanglongsong
** :200912
*****************************************************************/
#include "LSD_ES44X1_LCD.h"
#include <stdlib.h>

#define   DEFINE_CLEAR_ZERO
/*****************************************************************
Clear_More_Zero
ڲunsigned char *Ram_Ptr,unsigned char Ptr_Le
˵: Ram_Ptr:ַ
          Ptr_Le󳤶
ڲ
:ַ"0".ǷִȡںDEFINE_CLEAR_ZEROĶ
ƣhls
******************************************************************/
void Clear_More_Zero( unsigned char *Ram_Ptr,unsigned char Ptr_Len )
{
#if defined(DEFINE_CLEAR_ZERO)
     for(signed char i=0;i<Ptr_Len;i++)
     {
         if((!(((Ram_Ptr[i]&0xF0) == (Digit_Table[ZERO_SIGN]&0xF0))&&((Ram_Ptr[i+1]&0x0F) == (Digit_Table[ZERO_SIGN]&0x0F))))
          &&(!(((Ram_Ptr[i]&0xF0) == (SPACE&0xF0))&&((Ram_Ptr[i+1]&0x0F) == (SPACE&0x0F)))))
             break;
         else
         {
             Ram_Ptr[i] &= 0x0F;
             Ram_Ptr[i+1] &= 0xF0;
         }
     }
#else
     Nothing();
#endif //DEFINE_CLEAR_ZERO
}
/*****************************************************************
LCD_Screen_Write
ڲunsigned char *Write_Ptr
˵:ⲿԴ׵ַ˵ַεԴݴLCDMEM
ڲ
:RAMеľԴתƵLCDԴ棬ʵʾ
ƣhls
******************************************************************/
void LCD_Screen_Write( unsigned char *Write_Ptr,unsigned char Wr_Len )
{
    for( unsigned char i=0;i<Wr_Len;i++,Write_Ptr++ )
    {
        LCD_Write(i,*Write_Ptr);
    }
}
/******************************************************************
BCD_Operation
ڲunsigned char *BCD_Buff,Type_Long_Array *Source_Buff
˵: BCD_Buff:תBCD
          Source_BuffתݼĴ
ڲ
:HEXʽݰתBCD
ƣhls
******************************************************************/
void BCD_Operation(unsigned char *BCD_Buff,Type_Long_Array *Source_Buff)
{
    Type_Long_Array Temp_Parameter;

    switch( PAGE_OFFSET|DISP_KEY)
    {
      case  LCD_PF1:
      case  LCD_PF2:
        {
            if(Source_Buff->Byte[1]&BYTE_MSB )                                      //Ϊȡֵ
            {
                Temp_Parameter.Value_L = abs((int)Source_Buff->Value_L);            //ֵ
                NEGA_FLAG = SET;
            }
            else
            {
                Temp_Parameter.Value_L = Source_Buff->Value_L;                     //ԭ
                NEGA_FLAG = RESET;
            }
        } break;
      default:
        {
            if(Source_Buff->Byte[3]&BYTE_MSB )                                      //Ϊȡֵ
            {
                Temp_Parameter.Value_L = labs(Source_Buff->Value_L);                //ֵ
                NEGA_FLAG = SET;
            }
            else
            {
                Temp_Parameter.Value_L = Source_Buff->Value_L;                     //ԭ
                NEGA_FLAG = RESET;
            }
        }break;
    }
    _BIN_BCD(Temp_Parameter.Byte,BCD_Buff);                                //ʾBCD봦
}
/*****************************************************************
Display_Operation
ڲunsigned char Disp_Index
˵: ʾɴ˲ʾһҳ
ڲ
:ҪʾʾRAMõײ㺯תƵLCDMEM
ƣhls
******************************************************************/
void Display_Operation( unsigned char Disp_Index )
{
    unsigned char Disp_Mirror_RAM[20]={0};
    unsigned char BCD_Buffer[5]={0};

    switch( PAGE_OFFSET|Disp_Index)
    {
    case LCD_POW_P1://1
        {
            BCD_Operation(BCD_Buffer,(Type_Long_Array*)Parameter_Ptr[Disp_Index]);
            Disp_Mirror_RAM[LOCATION_0] = (Digit_Table[BCD_Buffer[3]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_1] = (Digit_Table[BCD_Buffer[3]>>4]&0x0F)+(Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_2] = (Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[2]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_3] = (Digit_Table[BCD_Buffer[2]>>4]&0x0F)|SEG_P4+(Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_4] = (Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0x0F);
            Disp_Mirror_RAM[LOCATION_4P5] = (Digit_Table[BCD_Buffer[1]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_5] = (Digit_Table[BCD_Buffer[1]>>4]&0x0F)+(Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_6] = (Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[0]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_7] = (Digit_Table[BCD_Buffer[0]>>4]&0x0F)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_8] = (Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0x0F)|SEG_S37;
            Clear_More_Zero(Disp_Mirror_RAM,15);

          Disp_Mirror_RAM[LOCATION_INDEX-1] = (Digit_Table[1]&0xF0)+(Disp_Mirror_RAM[LOCATION_INDEX-1]&0x0F);
          Disp_Mirror_RAM[LOCATION_INDEX] = (Disp_Mirror_RAM[LOCATION_INDEX]&0xF0)+(Digit_Table[1]&0x0F);
        }break;
    case LCD_POW_P2://2
        {
            BCD_Operation(BCD_Buffer,(Type_Long_Array*)Parameter_Ptr[Disp_Index]);
            Disp_Mirror_RAM[LOCATION_0] = (Digit_Table[BCD_Buffer[3]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_1] = (Digit_Table[BCD_Buffer[3]>>4]&0x0F)+(Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_2] = (Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[2]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_3] = (Digit_Table[BCD_Buffer[2]>>4]&0x0F)|SEG_P4+(Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_4] = (Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0x0F);
            Disp_Mirror_RAM[LOCATION_4P5] = (Digit_Table[BCD_Buffer[1]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_5] = (Digit_Table[BCD_Buffer[1]>>4]&0x0F)+(Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_6] = (Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[0]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_7] = (Digit_Table[BCD_Buffer[0]>>4]&0x0F)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_8] = (Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0x0F)|SEG_S37;
            Clear_More_Zero(Disp_Mirror_RAM,15);

          Disp_Mirror_RAM[LOCATION_INDEX-1] = (Digit_Table[2]&0xF0)+(Disp_Mirror_RAM[LOCATION_INDEX-1]&0x0F);
          Disp_Mirror_RAM[LOCATION_INDEX] = (Disp_Mirror_RAM[LOCATION_INDEX]&0xF0)+(Digit_Table[2]&0x0F);
        }break;
    case LCD_POW_Q1://3
      {
          BCD_Operation(BCD_Buffer,(Type_Long_Array*)Parameter_Ptr[Disp_Index]);
          Disp_Mirror_RAM[LOCATION_0] = (Digit_Table[BCD_Buffer[3]>>4]&0xF0);
          Disp_Mirror_RAM[LOCATION_1] = (Digit_Table[BCD_Buffer[3]>>4]&0x0F)+(Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0xF0);
          Disp_Mirror_RAM[LOCATION_2] = (Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[2]>>4]&0xF0);
          Disp_Mirror_RAM[LOCATION_3] = (Digit_Table[BCD_Buffer[2]>>4]&0x0F)|SEG_P4+(Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0xF0);
          Disp_Mirror_RAM[LOCATION_4] = (Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0x0F);
          Disp_Mirror_RAM[LOCATION_4P5] = (Digit_Table[BCD_Buffer[1]>>4]&0xF0);
          Disp_Mirror_RAM[LOCATION_5] = (Digit_Table[BCD_Buffer[1]>>4]&0x0F)+(Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0xF0);
          Disp_Mirror_RAM[LOCATION_6] = (Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[0]>>4]&0xF0);
          Disp_Mirror_RAM[LOCATION_7] = (Digit_Table[BCD_Buffer[0]>>4]&0x0F)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0xF0);
          Disp_Mirror_RAM[LOCATION_8] = (Disp_Mirror_RAM[LOCATION_8]&0xF0)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0x0F)|SEG_V|SEG_I;
          Clear_More_Zero(Disp_Mirror_RAM,15);

          Disp_Mirror_RAM[LOCATION_INDEX-1] = (Digit_Table[3]&0xF0)+(Disp_Mirror_RAM[LOCATION_INDEX-1]&0x0F);
          Disp_Mirror_RAM[LOCATION_INDEX] = (Disp_Mirror_RAM[LOCATION_INDEX]&0xF0)+(Digit_Table[3]&0x0F);
      }break;
    case LCD_POW_Q2://4
      {
          BCD_Operation(BCD_Buffer,(Type_Long_Array*)Parameter_Ptr[Disp_Index]);
          Disp_Mirror_RAM[LOCATION_0] = (Digit_Table[BCD_Buffer[3]>>4]&0xF0);
          Disp_Mirror_RAM[LOCATION_1] = (Digit_Table[BCD_Buffer[3]>>4]&0x0F)+(Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0xF0);
          Disp_Mirror_RAM[LOCATION_2] = (Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[2]>>4]&0xF0);
          Disp_Mirror_RAM[LOCATION_3] = (Digit_Table[BCD_Buffer[2]>>4]&0x0F)|SEG_P4+(Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0xF0);
          Disp_Mirror_RAM[LOCATION_4] = (Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0x0F);
          Disp_Mirror_RAM[LOCATION_4P5] = (Digit_Table[BCD_Buffer[1]>>4]&0xF0);
          Disp_Mirror_RAM[LOCATION_5] = (Digit_Table[BCD_Buffer[1]>>4]&0x0F)+(Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0xF0);
          Disp_Mirror_RAM[LOCATION_6] = (Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[0]>>4]&0xF0);
          Disp_Mirror_RAM[LOCATION_7] = (Digit_Table[BCD_Buffer[0]>>4]&0x0F)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0xF0);
          Disp_Mirror_RAM[LOCATION_8] = (Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0x0F)|SEG_V|SEG_I;
          Clear_More_Zero(Disp_Mirror_RAM,15);

          Disp_Mirror_RAM[LOCATION_INDEX-1] = (Digit_Table[4]&0xF0)+(Disp_Mirror_RAM[LOCATION_INDEX-1]&0x0F);
          Disp_Mirror_RAM[LOCATION_INDEX] = (Disp_Mirror_RAM[LOCATION_INDEX]&0xF0)+(Digit_Table[4]&0x0F);
      }break;
    case LCD_POW_S1://5
        {
            BCD_Operation(BCD_Buffer,(Type_Long_Array*)Parameter_Ptr[Disp_Index]);
            Disp_Mirror_RAM[LOCATION_0] = (Digit_Table[BCD_Buffer[3]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_1] = (Digit_Table[BCD_Buffer[3]>>4]&0x0F)+(Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_2] = (Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[2]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_3] = (Digit_Table[BCD_Buffer[2]>>4]&0x0F)|SEG_P4+(Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_4] = (Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0x0F);
            Disp_Mirror_RAM[LOCATION_4P5] = (Digit_Table[BCD_Buffer[1]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_5] = (Digit_Table[BCD_Buffer[1]>>4]&0x0F)+(Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_6] = (Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[0]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_7] = (Digit_Table[BCD_Buffer[0]>>4]&0x0F)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_8] = (Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0x0F)|SEG_V|SEG_I;
            Clear_More_Zero(Disp_Mirror_RAM,15);

          Disp_Mirror_RAM[LOCATION_INDEX-1] = (Digit_Table[5]&0xF0)+(Disp_Mirror_RAM[LOCATION_INDEX-1]&0x0F);
          Disp_Mirror_RAM[LOCATION_INDEX] = (Disp_Mirror_RAM[LOCATION_INDEX]&0xF0)+(Digit_Table[5]&0x0F);
        }break;
    case LCD_POW_S2://6
        {
            BCD_Operation(BCD_Buffer,(Type_Long_Array*)Parameter_Ptr[Disp_Index]);
            Disp_Mirror_RAM[LOCATION_0] = (Digit_Table[BCD_Buffer[3]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_1] = (Digit_Table[BCD_Buffer[3]>>4]&0x0F)+(Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_2] = (Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[2]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_3] = (Digit_Table[BCD_Buffer[2]>>4]&0x0F)|SEG_P4+(Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_4] = (Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0x0F);
            Disp_Mirror_RAM[LOCATION_4P5] = (Digit_Table[BCD_Buffer[1]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_5] = (Digit_Table[BCD_Buffer[1]>>4]&0x0F)+(Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_6] = (Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[0]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_7] = (Digit_Table[BCD_Buffer[0]>>4]&0x0F)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_8] = (Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0x0F)|SEG_V|SEG_I;
            Clear_More_Zero(Disp_Mirror_RAM,15);

          Disp_Mirror_RAM[LOCATION_INDEX-1] = (Digit_Table[6]&0xF0)+(Disp_Mirror_RAM[LOCATION_INDEX-1]&0x0F);
          Disp_Mirror_RAM[LOCATION_INDEX] = (Disp_Mirror_RAM[LOCATION_INDEX]&0xF0)+(Digit_Table[6]&0x0F);
        }break;
      case LCD_VRMS://7
        {
            BCD_Operation(BCD_Buffer,(Type_Long_Array*)Parameter_Ptr[Disp_Index]);
            Disp_Mirror_RAM[LOCATION_0] = (Digit_Table[BCD_Buffer[3]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_1] = (Digit_Table[BCD_Buffer[3]>>4]&0x0F)+(Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_2] = (Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[2]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_3] = (Digit_Table[BCD_Buffer[2]>>4]&0x0F)+(Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_4] = (Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0x0F);
            Disp_Mirror_RAM[LOCATION_4P5] = (Digit_Table[BCD_Buffer[1]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_5] = (Digit_Table[BCD_Buffer[1]>>4]&0x0F)+(Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_6] = (Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0x0F)|SEG_P6+(Digit_Table[BCD_Buffer[0]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_7] = (Digit_Table[BCD_Buffer[0]>>4]&0x0F)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_8] = (Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0x0F)|SEG_V;
            Clear_More_Zero(Disp_Mirror_RAM,15);

            Disp_Mirror_RAM[LOCATION_INDEX-1] = (Digit_Table[7]&0xF0)+(Disp_Mirror_RAM[LOCATION_INDEX-1]&0x0F);
            Disp_Mirror_RAM[LOCATION_INDEX] = (Disp_Mirror_RAM[LOCATION_INDEX]&0xF0)+(Digit_Table[7]&0x0F);
        }break;
      case LCD_CUR1://8
        {
            BCD_Operation(BCD_Buffer,(Type_Long_Array*)Parameter_Ptr[Disp_Index]);
            Disp_Mirror_RAM[LOCATION_0] = (Digit_Table[BCD_Buffer[3]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_1] = (Digit_Table[BCD_Buffer[3]>>4]&0x0F)+(Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_2] = (Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[2]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_3] = (Digit_Table[BCD_Buffer[2]>>4]&0x0F)+(Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_4] = (Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0x0F);
            Disp_Mirror_RAM[LOCATION_4P5] = (Digit_Table[BCD_Buffer[1]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_5] = (Digit_Table[BCD_Buffer[1]>>4]&0x0F)+(Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_6] = (Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0x0F)|SEG_P6+(Digit_Table[BCD_Buffer[0]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_7] = (Digit_Table[BCD_Buffer[0]>>4]&0x0F)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_8] = (Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0x0F)|SEG_I;
            Clear_More_Zero(Disp_Mirror_RAM,15);

          Disp_Mirror_RAM[LOCATION_INDEX-1] = (Digit_Table[8]&0xF0)+(Disp_Mirror_RAM[LOCATION_INDEX-1]&0x0F);
          Disp_Mirror_RAM[LOCATION_INDEX] = (Disp_Mirror_RAM[LOCATION_INDEX]&0xF0)+(Digit_Table[8]&0x0F);
        }break;
    case LCD_CUR2://9
        {
            BCD_Operation(BCD_Buffer,(Type_Long_Array*)Parameter_Ptr[Disp_Index]);
            Disp_Mirror_RAM[LOCATION_0] = (Digit_Table[BCD_Buffer[3]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_1] = (Digit_Table[BCD_Buffer[3]>>4]&0x0F)+(Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_2] = (Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[2]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_3] = (Digit_Table[BCD_Buffer[2]>>4]&0x0F)+(Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_4] = (Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0x0F);
            Disp_Mirror_RAM[LOCATION_4P5] = (Digit_Table[BCD_Buffer[1]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_5] = (Digit_Table[BCD_Buffer[1]>>4]&0x0F)+(Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_6] = (Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0x0F)|SEG_P6+(Digit_Table[BCD_Buffer[0]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_7] = (Digit_Table[BCD_Buffer[0]>>4]&0x0F)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_8] = (Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0x0F)|SEG_I;
            Clear_More_Zero(Disp_Mirror_RAM,15);

          Disp_Mirror_RAM[LOCATION_INDEX-1] = (Digit_Table[9]&0xF0)+(Disp_Mirror_RAM[LOCATION_INDEX-1]&0x0F);
          Disp_Mirror_RAM[LOCATION_INDEX] = (Disp_Mirror_RAM[LOCATION_INDEX]&0xF0)+(Digit_Table[9]&0x0F);
        }break;
    case LCD_PF1://10
        {
            BCD_Operation(BCD_Buffer,(Type_Long_Array*)Parameter_Ptr[Disp_Index]);
            Disp_Mirror_RAM[LOCATION_0] = (Digit_Table[BCD_Buffer[3]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_1] = (Digit_Table[BCD_Buffer[3]>>4]&0x0F)+(Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_2] = (Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[2]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_3] = (Digit_Table[BCD_Buffer[2]>>4]&0x0F)+(Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_4] = (Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0x0F);
            Disp_Mirror_RAM[LOCATION_4P5] = (Digit_Table[BCD_Buffer[1]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_5] = (Digit_Table[BCD_Buffer[1]>>4]&0x0F)|SEG_P5+(Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_6] = (Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[0]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_7] = (Digit_Table[BCD_Buffer[0]>>4]&0x0F)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_8] = (Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0x0F);
            Clear_More_Zero(Disp_Mirror_RAM,15);

          Disp_Mirror_RAM[LOCATION_INDEX-1] = (Digit_Table[0]&0xF0)+(Disp_Mirror_RAM[LOCATION_INDEX-1]&0x0F);
          Disp_Mirror_RAM[LOCATION_INDEX] = ((Disp_Mirror_RAM[LOCATION_INDEX]&0xF0)+(Digit_Table[0]&0x0F))|SEG_P1;
        }break;
    case LCD_PF2://11
        {
            BCD_Operation(BCD_Buffer,(Type_Long_Array*)Parameter_Ptr[Disp_Index]);
            Disp_Mirror_RAM[LOCATION_0] = (Digit_Table[BCD_Buffer[3]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_1] = (Digit_Table[BCD_Buffer[3]>>4]&0x0F)+(Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_2] = (Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[2]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_3] = (Digit_Table[BCD_Buffer[2]>>4]&0x0F)+(Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_4] = (Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0x0F);
            Disp_Mirror_RAM[LOCATION_4P5] = (Digit_Table[BCD_Buffer[1]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_5] = (Digit_Table[BCD_Buffer[1]>>4]&0x0F)|SEG_P5+(Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_6] = (Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[0]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_7] = (Digit_Table[BCD_Buffer[0]>>4]&0x0F)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_8] = (Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0x0F);
            Clear_More_Zero(Disp_Mirror_RAM,15);

          Disp_Mirror_RAM[LOCATION_INDEX-1] = (Digit_Table[1]&0xF0)+(Disp_Mirror_RAM[LOCATION_INDEX-1]&0x0F);
          Disp_Mirror_RAM[LOCATION_INDEX] = ((Disp_Mirror_RAM[LOCATION_INDEX]&0xF0)+(Digit_Table[1]&0x0F))|SEG_P1;
        }break;
    case LCD_FREQ://12
        {
            BCD_Operation(BCD_Buffer,(Type_Long_Array*)Parameter_Ptr[Disp_Index]);
            Disp_Mirror_RAM[LOCATION_0] = (Digit_Table[BCD_Buffer[3]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_1] = (Digit_Table[BCD_Buffer[3]>>4]&0x0F)+(Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_2] = (Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[2]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_3] = (Digit_Table[BCD_Buffer[2]>>4]&0x0F)+(Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_4] = (Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0x0F);
            Disp_Mirror_RAM[LOCATION_4P5] = (Digit_Table[BCD_Buffer[1]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_5] = (Digit_Table[BCD_Buffer[1]>>4]&0x0F)+(Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_6] = (Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0x0F)|SEG_P6+(Digit_Table[BCD_Buffer[0]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_7] = (Digit_Table[BCD_Buffer[0]>>4]&0x0F)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_8] = (Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0x0F)|SEG_S36;
            Clear_More_Zero(Disp_Mirror_RAM,15);

          Disp_Mirror_RAM[LOCATION_INDEX-1] = (Digit_Table[2]&0xF0)+(Disp_Mirror_RAM[LOCATION_INDEX-1]&0x0F);
          Disp_Mirror_RAM[LOCATION_INDEX] = ((Disp_Mirror_RAM[LOCATION_INDEX]&0xF0)+(Digit_Table[2]&0x0F))|SEG_P1;
         }break;
    case LCD_EC://13
        {
            memcpy(BCD_Buffer,EC_REG,sizeof(EC_Type));
            Disp_Mirror_RAM[LOCATION_0] = (Digit_Table[BCD_Buffer[3]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_1] = (Digit_Table[BCD_Buffer[3]>>4]&0x0F)+(Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_2] = (Digit_Table[BCD_Buffer[3]&CHAR_LOW_4BIT]&0x0F)+(Digit_Table[BCD_Buffer[2]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_3] = (Digit_Table[BCD_Buffer[2]>>4]&0x0F)+(Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_4] = (Digit_Table[BCD_Buffer[2]&CHAR_LOW_4BIT]&0x0F);
            Disp_Mirror_RAM[LOCATION_4P5] = (Digit_Table[BCD_Buffer[1]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_5] = (Digit_Table[BCD_Buffer[1]>>4]&0x0F)+(Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_6] = (Digit_Table[BCD_Buffer[1]&CHAR_LOW_4BIT]&0x0F)|SEG_P6+(Digit_Table[BCD_Buffer[0]>>4]&0xF0);
            Disp_Mirror_RAM[LOCATION_7] = (Digit_Table[BCD_Buffer[0]>>4]&0x0F)+(Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0xF0);
            Disp_Mirror_RAM[LOCATION_8] = (Digit_Table[BCD_Buffer[0]&CHAR_LOW_4BIT]&0x0F)|SEG_S36|SEG_S37;
            Disp_Mirror_RAM[LOCATION_EC] = EC_SIGN;
          Disp_Mirror_RAM[LOCATION_INDEX-1] = (Digit_Table[3]&0xF0)+(Disp_Mirror_RAM[LOCATION_INDEX-1]&0x0F);
          Disp_Mirror_RAM[LOCATION_INDEX] = ((Disp_Mirror_RAM[LOCATION_INDEX]&0xF0)+(Digit_Table[3]&0x0F))|SEG_P1;
        }break;
    default:
        break;
    }
    Disp_Mirror_RAM[5]  = COM_DISP_FALG?Disp_Mirror_RAM[5]|CALL_SIGN:Disp_Mirror_RAM[5]&~CALL_SIGN;     // ͨŷʾ
    Disp_Mirror_RAM[16] = NEGA_FLAG?Disp_Mirror_RAM[15]|MINUS_SIGN:Disp_Mirror_RAM[15]&~MINUS_SIGN;     // LCDϸŴ
    Disp_Mirror_RAM[15] = PROG_STATE?Disp_Mirror_RAM[15]|LACK_SIGN:Disp_Mirror_RAM[15]&~LACK_SIGN;      // LCDϸŴ
    LCD_Screen_Write(Disp_Mirror_RAM,sizeof(Disp_Mirror_RAM));                                          // RAMӳ䵽LCDMEN
    COM_DISP_FALG = RESET;
    DISP_FLAG = RESET;
}